/* TBCppA.h: macros for coping with the problem of doubling __VA_ARGS__.
   in TBCppA project: tracer-based CPP analyzer.
   Copyright (c) 2006   Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
   $Id: TBCppA.h,v 1.1 2006/11/08 13:34:49 gondow Exp gondow $ */

#define TBCPPA_PASTE(a, b)  TBCPPA_PASTE2(a, b)
#define TBCPPA_PASTE2(a, b) a##b
/* this macro can count macro arguments up to 26 (13 after halved) */
#define TBCPPA_COUNT_AND_HALVE(...) TBCPPA_COUNT2(__VA_ARGS__, \
                   13,!,12,!,11,!,10,!,9,!,8,!,7,!,6,!,5,!,4,!,3,!,2,!,1,!,0)
#define TBCPPA_COUNT2(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,\
                      count,...) count
#define TBCPPA_FIRST_HALF_ARGS(...) \
        TBCPPA_PASTE(TBCPPA_FIRST,   \
                     TBCPPA_COUNT_AND_HALVE(__VA_ARGS__))(__VA_ARGS__)
#define TBCPPA_APPLY(func, vargs)   func (vargs)
#define TBCPPA_FIRST1(a,...)                          a
#define TBCPPA_FIRST2(a,b,...)                        a,b
#define TBCPPA_FIRST3(a,b,c,...)                      a,b,c
#define TBCPPA_FIRST4(a,b,c,d,...)                    a,b,c,d
#define TBCPPA_FIRST5(a,b,c,d,e,...)                  a,b,c,d,e
#define TBCPPA_FIRST6(a,b,c,d,e,f,...)                a,b,c,d,e,f
#define TBCPPA_FIRST7(a,b,c,d,e,f,g,...)              a,b,c,d,e,f,g
#define TBCPPA_FIRST8(a,b,c,d,e,f,g,h,...)            a,b,c,d,e,f,g,h
#define TBCPPA_FIRST9(a,b,c,d,e,f,g,h,i,...)          a,b,c,d,e,f,g,h,i
#define TBCPPA_FIRST10(a,b,c,d,e,f,g,h,i,j,...)       a,b,c,d,e,f,g,h,i,j
#define TBCPPA_FIRST11(a,b,c,d,e,f,g,h,i,j,k,...)     a,b,c,d,e,f,g,h,i,j,k
#define TBCPPA_FIRST12(a,b,c,d,e,f,g,h,i,j,k,l,...)   a,b,c,d,e,f,g,h,i,j,k,l
#define TBCPPA_FIRST13(a,b,c,d,e,f,g,h,i,j,k,l,m,...) a,b,c,d,e,f,g,h,i,j,k,l,m

#if 0
#define TBCPPA_REST1(a,...)                           __VA_ARGS__
#define TBCPPA_REST2(a,b,...)                         __VA_ARGS__
#define TBCPPA_REST3(a,b,c,...)                       __VA_ARGS__
#define TBCPPA_REST4(a,b,c,d,...)                     __VA_ARGS__
#define TBCPPA_REST5(a,b,c,d,e,...)                   __VA_ARGS__
#define TBCPPA_REST6(a,b,c,d,e,f,...)                 __VA_ARGS__
#define TBCPPA_REST7(a,b,c,d,e,f,g,...)               __VA_ARGS__
#define TBCPPA_REST8(a,b,c,d,e,f,g,h,...)             __VA_ARGS__
#define TBCPPA_REST9(a,b,c,d,e,f,g,h,i,...)           __VA_ARGS__
#define TBCPPA_REST10(a,b,c,d,e,f,g,h,i,j,...)        __VA_ARGS__
#define TBCPPA_REST11(a,b,c,d,e,f,g,h,i,j,k,...)      __VA_ARGS__
#define TBCPPA_REST12(a,b,c,d,e,f,g,h,i,j,k,l,...)    __VA_ARGS__
#define TBCPPA_REST13(a,b,c,d,e,f,g,h,i,j,k,l,m,...)  __VA_ARGS__
#endif
 
/* ===================================================================== */
#if 0
#define FOO(x, y, ...)    (x, y, (__VA_ARGS__))
#define FOO_1528552(...)   TBCPPA_APPLY (FOO, TBCPPA_FIRST_HALF_ARGS (__VA_ARGS__))
FOO_1528552 (10, 20, 30, 40, 100, 200, 300, 400)
/* => FOO(10, 20, 30, 40) => (10, 20, (30, 40)) */
#endif
#if 0
#define FOO(x, y, ...)    (x, y, (__VA_ARGS__))
#define FOO_1528552(x, y, ...)   TBCPPA_APPLY (FOO, TBCPPA_FIRST_HALF_ARGS (x, y, __VA_ARGS__))
FOO_1528552 (10, 20, 30, 40, 100, 200, 300, 400)
#endif
