/* misc utility
   in TBCppA project: tracer-based CPP analyzer.
   Copyright (c) 2006   Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
   $Id: misc.h,v 1.5 2006/11/01 11:36:57 gondow Exp gondow $ */

#ifndef TBCPPA_MISC_H
#define TBCPPA_MISC_H
#include <sys/types.h> /* for mode_t */
#include <sys/stat.h>
#define EFREE(p)     efree(p, __FILE__, __LINE__)

char *chop    (char *s);
char *chop_nl (char *s); /* chop if the last char is LF */
char *chop_char (char *s, int c);
int  count_char (char *s, int c);
char *substring (char *s, int from, int to);
int  mkdirhier (char *dir, mode_t mode);
FILE *fopen_with_mkdir (const char *path, const char *mode);
void *emalloc (int size);
void *erealloc(void *ptr, size_t size);
void efree   (void *ptr, char *file, int line);
char *estrdup (const char *s);
int  easprintf (char **sp, const char *fmt, ...);
char *comment_to_space (char *s);
char *str_to_xml (char *s);
char *str_to_xml2 (char *s);
void xml_encode (FILE *fp, char *text);
#endif /* TBCPPA_MISC_H */

