/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     IDENTIFIER2 = 259,
     CONSTANT = 260,
     STRING_LITERAL = 261,
     PUNCTUATOR = 262,
     NEWLINE = 263,
     NON_WHITE_SPACE_CHAR = 264,
     H_HEADER_NAME = 265,
     Q_HEADER_NAME = 266,
     INCLUDE = 267,
     INCLUDE_NEXT = 268,
     DEFINE = 269,
     UNDEF = 270,
     IF = 271,
     IFDEF = 272,
     IFNDEF = 273,
     ELIF = 274,
     ELSE = 275,
     ENDIF = 276,
     ELLIPSIS = 277,
     SHARPSHARP = 278,
     LINE = 279,
     ERROR = 280,
     PRAGMA = 281,
     EMPTY = 282
   };
#endif
/* Tokens.  */
#define IDENTIFIER 258
#define IDENTIFIER2 259
#define CONSTANT 260
#define STRING_LITERAL 261
#define PUNCTUATOR 262
#define NEWLINE 263
#define NON_WHITE_SPACE_CHAR 264
#define H_HEADER_NAME 265
#define Q_HEADER_NAME 266
#define INCLUDE 267
#define INCLUDE_NEXT 268
#define DEFINE 269
#define UNDEF 270
#define IF 271
#define IFDEF 272
#define IFNDEF 273
#define ELIF 274
#define ELSE 275
#define ENDIF 276
#define ELLIPSIS 277
#define SHARPSHARP 278
#define LINE 279
#define ERROR 280
#define PRAGMA 281
#define EMPTY 282




/* Copy the first part of user declarations.  */
#line 6 "tadd.y"

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <assert.h>
#include <sys/param.h>
#include <signal.h>

#include "tadd.h"
#include "misc.h"
#include "pi.h"
#include "list.h"
#include "tef.h"

#define YYDEBUG 1
#define YYERROR_VERBOSE

#define NULLIFY(y)  ((y).str = (y).str2 = (y).tadd = NULL, (y).list = NULL)
#define MOVE(x,y)   ((x).str  = (y).str,  (x).str2 = (y).str2, \
                     (x).tadd = (y).tadd, (x).list = (y).list, \
                     NULLIFY(y))
#define MOVE1_FMT(x,y,fmt)    (easprintf (&x.str,  fmt, y.str),   \
			       easprintf (&x.str2, fmt, y.str2),  \
			       easprintf (&x.tadd, fmt, y.tadd),  \
			       x.list = NULL, free_lval (&y))
#define MOVE2_FMT(x,y,z,fmt)  (easprintf (&x.str,  fmt, y.str,  z.str),   \
			       easprintf (&x.str2, fmt, y.str2, z.str2),  \
			       easprintf (&x.tadd, fmt, y.tadd, z.tadd),  \
			       x.list = NULL, free_lval (&y), free_lval (&z))
#define BOTTOM(x,y) (x.str  = estrdup (y), x.str2 = estrdup (y), \
                     x.tadd = estrdup (y), x.list = NULL)

FILE *lexout;
char *absolute_path;
int  idnum;

static void lex_sync (void);
static void free_lval  (struct lval *lval);
static void free_lval2 (struct lval *lval);
static int  yyerror (char *mesg);
static void print_usage (void);
static void process_options (int argc, char *argv []);
static void output_xml_begin (char *file);
static void output_xml_end   (void);
static void output_params    (struct CDLL *list);
static void output_params2   (struct CDLL *list);
static char *get_text (int from, int to);
static void output_check_def_macro (char *macro_name, int is_defined);
static void tadd (char *file);
static void output_error_text (int idnum, int first_line, int first_column,
			       int last_line, int last_column);

static struct CDLL *cdll_head = NULL;
static int id_counter         = 0;
static int define_func_flag   = 0;
static struct {
    char **file;
    int  file_num;
    char *dir;
    char *db_file;
    char *lex_suffix;
    char *double_suffix;
    char *check_def_suffix;
    int  conservative;
} args = {
    NULL,          /* char **file; */
    0,             /* int  file_num; */
    "./TBCppA",    /* char *dir; */
    "db_file",     /* char *db_file; */
    ".lex",        /* char *lex_suffix; */
    "_1528552",    /* char *double_suffix; */ /* Titech zip code :-) */
    "_3141592_is_defined", /* char *check_def_suffix; */
    0,             /* int  conservative; */
};

char **double_suffix_p = &args.double_suffix;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 252 "tadd.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
    YYLTYPE yyls;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   530

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  32
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  43
/* YYNRULES -- Number of rules.  */
#define YYNRULES  110
/* YYNRULES -- Number of states.  */
#define YYNSTATES  171

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   282

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    28,     2,     2,     2,     2,
      31,    29,     2,     2,    30,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     5,     6,     9,    10,    17,    21,
      25,    29,    33,    37,    41,    48,    57,    66,    77,    81,
      85,    89,    93,    97,   100,   103,   104,   110,   111,   117,
     118,   124,   125,   126,   133,   134,   135,   140,   141,   143,
     145,   149,   151,   152,   154,   156,   159,   161,   163,   165,
     167,   169,   171,   173,   175,   177,   179,   181,   184,   188,
     189,   191,   193,   196,   198,   200,   202,   204,   206,   208,
     210,   212,   214,   216,   218,   220,   222,   224,   226,   231,
     236,   237,   239,   240,   242,   244,   247,   249,   252,   254,
     256,   260,   262,   264,   266,   270,   271,   273,   275,   278,
     280,   282,   283,   285,   287,   290,   292,   294,   296,   300,
     302
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      35,     0,    -1,    -1,    -1,    -1,    35,    36,    -1,    -1,
      37,    38,    42,    44,    21,     8,    -1,    12,    10,     8,
      -1,    12,    11,     8,    -1,    12,    50,     8,    -1,    13,
      10,     8,    -1,    13,    11,     8,    -1,    13,    50,     8,
      -1,    14,    33,     3,    49,    34,     8,    -1,    14,    33,
       4,    46,    29,    49,    34,     8,    -1,    14,    33,     4,
      22,    29,    49,    34,     8,    -1,    14,    33,     4,    47,
      30,    22,    29,    49,    34,     8,    -1,    15,     3,     8,
      -1,    24,    50,     8,    -1,    25,    49,     8,    -1,    26,
      49,     8,    -1,    27,    49,     8,    -1,    53,     8,    -1,
       1,     8,    -1,    -1,    16,    50,     8,    39,    35,    -1,
      -1,    17,     3,     8,    40,    35,    -1,    -1,    18,     3,
       8,    41,    35,    -1,    -1,    -1,    42,    19,    50,     8,
      43,    35,    -1,    -1,    -1,    20,     8,    45,    35,    -1,
      -1,    47,    -1,     3,    -1,    47,    30,     3,    -1,     3,
      -1,    -1,    50,    -1,    51,    -1,    50,    51,    -1,    52,
      -1,    60,    -1,    31,    -1,    29,    -1,    30,    -1,    48,
      -1,     5,    -1,     6,    -1,     7,    -1,     9,    -1,    22,
      -1,    28,    48,    -1,    52,    23,    52,    -1,    -1,    54,
      -1,    55,    -1,    54,    55,    -1,    56,    -1,    59,    -1,
      31,    -1,    29,    -1,    30,    -1,    48,    -1,     5,    -1,
       6,    -1,     7,    -1,     9,    -1,    22,    -1,    28,    -1,
      23,    -1,    31,    -1,    29,    -1,     3,    57,    73,    58,
      -1,     3,    57,    74,    58,    -1,    -1,    64,    -1,    -1,
      63,    -1,    66,    -1,    63,    66,    -1,    65,    -1,    64,
      65,    -1,    56,    -1,    59,    -1,    31,    70,    29,    -1,
       8,    -1,    52,    -1,    60,    -1,    31,    67,    29,    -1,
      -1,    68,    -1,    69,    -1,    68,    69,    -1,    66,    -1,
      30,    -1,    -1,    71,    -1,    72,    -1,    71,    72,    -1,
      65,    -1,    30,    -1,    61,    -1,    73,    30,    61,    -1,
      62,    -1,    74,    30,    62,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   115,   115,   116,   119,   120,   124,   124,   144,   158,
     172,   188,   202,   216,   233,   252,   289,   324,   365,   381,
     394,   407,   420,   433,   439,   452,   451,   477,   476,   502,
     501,   530,   535,   534,   563,   568,   567,   592,   600,   612,
     622,   634,   685,   686,   690,   691,   698,   699,   700,   701,
     702,   707,   708,   709,   710,   711,   712,   713,   721,   733,
     734,   738,   739,   743,   744,   745,   746,   747,   752,   753,
     754,   755,   756,   757,   758,   759,   763,   772,   784,   849,
     915,   916,   920,   921,   925,   926,   934,   935,   943,   944,
     945,   946,   950,   951,   952,   956,   957,   961,   962,   970,
     971,   975,   976,   980,   981,   988,   989,   993,  1008,  1027,
    1042
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "IDENTIFIER2", "CONSTANT",
  "STRING_LITERAL", "PUNCTUATOR", "NEWLINE", "NON_WHITE_SPACE_CHAR",
  "H_HEADER_NAME", "Q_HEADER_NAME", "\"#include\"", "\"#include_next\"",
  "\"#define\"", "\"#undef\"", "\"#if\"", "\"#ifdef\"", "\"#ifndef\"",
  "\"#elif\"", "\"#else\"", "\"#endif\"", "\"...\"", "\"##\"", "\"#line\"",
  "\"#error\"", "\"#pragma\"", "\"#empty\"", "'#'", "')'", "','", "'('",
  "$accept", "DF_on", "DF_off", "group", "group_part", "@1", "if_group",
  "@2", "@3", "@4", "elif_groups", "@5", "else_group", "@6",
  "identifier_list_opt", "identifier_list", "identifier",
  "pp_tokens_define_opt", "pp_tokens_define", "preprocessing_token_define",
  "preprocessing_token_define_minus_paren_comma", "pp_tokens_opt",
  "pp_tokens", "preprocessing_token",
  "preprocessing_token_minus_paren_comma", "func_mc_left_paren",
  "func_mc_right_paren", "func_macro_call_plus_nl",
  "func_macro_call_define", "pp_tokens_minus_paren_comma_plus_nl_opt",
  "pp_tokens_define_minus_paren_comma_plus_func_opt",
  "pp_tokens_define_minus_paren_comma_plus_func",
  "pp_tokens_minus_paren_comma_plus_nl",
  "preprocessing_token_minus_paren_comma_plus_nl",
  "preprocessing_token_define_minus_paren_comma_plus_func",
  "pp_tokens_define_minus_paren_plus_func_opt",
  "pp_tokens_define_minus_paren_plus_func",
  "preprocessing_token_define_minus_paren_plus_func",
  "pp_tokens_minus_paren_plus_nl_opt", "pp_tokens_minus_paren_plus_nl",
  "preprocessing_token_minus_paren_plus_nl", "argument_list",
  "argument_list_define", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    35,    41,
      44,    40
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    32,    33,    34,    35,    35,    37,    36,    36,    36,
      36,    36,    36,    36,    36,    36,    36,    36,    36,    36,
      36,    36,    36,    36,    36,    39,    38,    40,    38,    41,
      38,    42,    43,    42,    44,    45,    44,    46,    46,    47,
      47,    48,    49,    49,    50,    50,    51,    51,    51,    51,
      51,    52,    52,    52,    52,    52,    52,    52,    52,    53,
      53,    54,    54,    55,    55,    55,    55,    55,    56,    56,
      56,    56,    56,    56,    56,    56,    57,    58,    59,    60,
      61,    61,    62,    62,    63,    63,    64,    64,    65,    65,
      65,    65,    66,    66,    66,    67,    67,    68,    68,    69,
      69,    70,    70,    71,    71,    72,    72,    73,    73,    74,
      74
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     0,     0,     2,     0,     6,     3,     3,
       3,     3,     3,     3,     6,     8,     8,    10,     3,     3,
       3,     3,     3,     2,     2,     0,     5,     0,     5,     0,
       5,     0,     0,     6,     0,     0,     4,     0,     1,     1,
       3,     1,     0,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     0,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     4,
       0,     1,     0,     1,     1,     2,     1,     2,     1,     1,
       3,     1,     1,     1,     3,     0,     1,     1,     2,     1,
       1,     0,     1,     1,     2,     1,     1,     1,     3,     1,
       3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,     1,     0,    41,    69,    70,    71,    72,     0,
       0,     2,     0,    73,    75,     0,    42,    42,    42,    74,
      66,    67,    65,     5,     0,    68,     0,    60,    61,    63,
      64,    24,    76,    80,    41,    52,    53,    54,    55,     0,
       0,    56,     0,    49,    50,    48,    51,     0,    44,    46,
      47,     0,     0,     0,     0,     0,     0,     0,    43,     0,
       0,     0,     0,     0,    31,    23,    62,    91,   101,    88,
      89,   107,    81,    86,     0,    82,     8,     9,    41,    57,
      10,    45,     0,    11,    12,    13,    42,    37,    18,    19,
      20,    21,    22,     0,     0,     0,    34,   106,   105,     0,
     102,   103,    87,    77,    80,    78,    95,    92,    93,   109,
      83,    84,     0,    58,     3,    39,     0,     0,    38,    25,
      27,    29,     0,     0,     0,    90,   104,   108,   100,    99,
       0,    96,    97,    85,    82,    79,     0,    42,    42,     0,
       4,     4,     4,     0,    35,     0,    94,    98,   110,    14,
       3,     3,    40,     0,     0,     0,     0,    32,     4,     7,
       0,     0,    42,     4,     0,    16,    15,     3,     0,     0,
      17
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    54,   136,     1,    23,    24,    64,   140,   141,   142,
      96,   163,   124,   158,   117,   118,    46,    57,    58,    48,
      49,    26,    27,    28,    29,    33,   105,    30,    50,    71,
     109,   110,    72,    73,   111,   130,   131,   132,    99,   100,
     101,    74,   112
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -128
static const yytype_int16 yypact[] =
{
    -128,   165,  -128,     4,   -14,  -128,  -128,  -128,  -128,    54,
      83,  -128,    22,  -128,  -128,   434,   434,   434,   434,  -128,
    -128,  -128,  -128,  -128,    11,  -128,    25,   101,  -128,  -128,
    -128,  -128,  -128,   463,   -14,  -128,  -128,  -128,  -128,    31,
      37,  -128,    27,  -128,  -128,  -128,  -128,   130,  -128,    26,
    -128,    46,    58,   349,    92,    60,   359,    65,   434,    73,
      79,   434,    59,    88,  -128,  -128,  -128,  -128,   388,  -128,
    -128,  -128,   463,  -128,    68,   475,  -128,  -128,  -128,  -128,
    -128,  -128,   502,  -128,  -128,  -128,   434,    12,  -128,  -128,
    -128,  -128,  -128,   395,    94,   107,    98,  -128,  -128,    71,
     388,  -128,  -128,  -128,   463,  -128,   470,    26,  -128,  -128,
     475,  -128,    90,  -128,  -128,  -128,    80,    96,    97,  -128,
    -128,  -128,   434,   118,   113,  -128,  -128,  -128,  -128,  -128,
      99,   470,  -128,  -128,   475,  -128,   132,   434,   434,    16,
    -128,  -128,  -128,   424,  -128,   133,  -128,  -128,  -128,  -128,
    -128,  -128,  -128,   114,   196,   227,   258,  -128,  -128,  -128,
     134,   136,   434,  -128,   320,  -128,  -128,  -128,   289,   137,
    -128
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
    -128,  -128,  -127,  -105,  -128,  -128,  -128,  -128,  -128,  -128,
    -128,  -128,  -128,  -128,  -128,  -128,    -1,   -16,    -6,   -42,
     -62,  -128,  -128,   120,   -26,   115,    36,   -25,   -54,    47,
      23,  -128,  -128,   -50,  -100,  -128,  -128,    19,  -128,  -128,
      56,  -128,  -128
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -60
static const yytype_int16 yytable[] =
{
      25,    59,    60,    47,    53,    81,   129,    69,    70,    56,
     133,    81,    31,   107,    81,   115,    81,    32,    98,   152,
     113,   108,   102,   160,   161,    55,    25,    61,    62,    63,
      78,   129,    25,    65,   116,   154,   155,   156,   153,    76,
     169,    79,    69,    70,   107,    77,    69,    70,   107,    82,
      98,    81,   108,   164,    83,    93,   108,    34,   168,    35,
      36,    37,    94,    38,    39,    40,    84,    25,    88,   107,
     114,    25,   107,    90,    69,    70,    41,   108,    69,    70,
     108,    91,    42,    43,    44,    45,    34,    92,    35,    36,
      37,    95,    38,    51,    52,    86,    87,   103,   104,    25,
     125,    81,   120,    25,     4,    41,     5,     6,     7,   137,
       8,    42,    43,    44,    45,   121,   143,   122,   123,   103,
     134,   150,   151,    13,    14,   138,   144,   139,   146,    19,
      20,    21,    22,    34,   145,    35,    36,    37,    80,    38,
     149,   159,   165,   162,   166,   170,   167,    66,   135,    75,
     147,   127,    41,    25,    25,    25,   126,   148,    42,    43,
      44,    45,     0,    25,     0,     2,     3,    25,     4,     0,
       5,     6,     7,   -59,     8,     0,     0,     9,    10,    11,
      12,    -6,    -6,    -6,     0,     0,     0,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,     3,     0,     4,
       0,     5,     6,     7,   -59,     8,     0,     0,     9,    10,
      11,    12,    -6,    -6,    -6,   -26,   -26,   -26,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,     3,     0,
       4,     0,     5,     6,     7,   -59,     8,     0,     0,     9,
      10,    11,    12,    -6,    -6,    -6,   -28,   -28,   -28,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,     3,
       0,     4,     0,     5,     6,     7,   -59,     8,     0,     0,
       9,    10,    11,    12,    -6,    -6,    -6,   -30,   -30,   -30,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
       3,     0,     4,     0,     5,     6,     7,   -59,     8,     0,
       0,     9,    10,    11,    12,    -6,    -6,    -6,   -33,   -33,
     -33,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,     3,     0,     4,     0,     5,     6,     7,   -59,     8,
       0,     0,     9,    10,    11,    12,    -6,    -6,    -6,     0,
       0,   -36,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    34,     0,    35,    36,    37,    85,    38,     0,
       0,     0,    34,     0,    35,    36,    37,    89,    38,     0,
       0,    41,     0,     0,     0,     0,     0,    42,    43,    44,
      45,    41,     0,     0,     0,     0,     0,    42,    43,    44,
      45,     4,     0,     5,     6,     7,    67,     8,    34,     0,
      35,    36,    37,   119,    38,     0,     0,     0,     0,     0,
      13,    14,     0,     0,     0,     0,    19,    41,    97,    68,
       0,     0,     0,    42,    43,    44,    45,    34,     0,    35,
      36,    37,   157,    38,     0,     0,     0,    34,     0,    35,
      36,    37,     0,    38,     0,     0,    41,     0,     0,     0,
       0,     0,    42,    43,    44,    45,    41,     0,     0,     0,
       0,     0,    42,    43,    44,    45,     4,     0,     5,     6,
       7,    67,     8,    34,     0,    35,    36,    37,    34,    38,
      35,    36,    37,     0,    38,    13,    14,     0,     0,     0,
       0,    19,    41,     0,    68,     0,     0,    41,    42,     0,
     128,   106,     0,    42,     0,    78,   106,    35,    36,    37,
       0,    38,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    41,     0,     0,     0,     0,     0,
      42
};

static const yytype_int16 yycheck[] =
{
       1,    17,    18,     9,    10,    47,   106,    33,    33,    15,
     110,    53,     8,    75,    56,     3,    58,    31,    68,     3,
      82,    75,    72,   150,   151,     3,    27,    16,    17,    18,
       3,   131,    33,     8,    22,   140,   141,   142,    22,     8,
     167,    42,    68,    68,   106,     8,    72,    72,   110,    23,
     100,    93,   106,   158,     8,    61,   110,     3,   163,     5,
       6,     7,     3,     9,    10,    11,     8,    68,     8,   131,
      86,    72,   134,     8,   100,   100,    22,   131,   104,   104,
     134,     8,    28,    29,    30,    31,     3,     8,     5,     6,
       7,     3,     9,    10,    11,     3,     4,    29,    30,   100,
      29,   143,     8,   104,     3,    22,     5,     6,     7,    29,
       9,    28,    29,    30,    31,     8,   122,    19,    20,    29,
      30,   137,   138,    22,    23,    29,     8,    30,    29,    28,
      29,    30,    31,     3,    21,     5,     6,     7,     8,     9,
       8,     8,     8,    29,     8,     8,   162,    27,   112,    34,
     131,   104,    22,   154,   155,   156,   100,   134,    28,    29,
      30,    31,    -1,   164,    -1,     0,     1,   168,     3,    -1,
       5,     6,     7,     8,     9,    -1,    -1,    12,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,     1,    -1,     3,
      -1,     5,     6,     7,     8,     9,    -1,    -1,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,     1,    -1,
       3,    -1,     5,     6,     7,     8,     9,    -1,    -1,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,     1,
      -1,     3,    -1,     5,     6,     7,     8,     9,    -1,    -1,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
       1,    -1,     3,    -1,     5,     6,     7,     8,     9,    -1,
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,     1,    -1,     3,    -1,     5,     6,     7,     8,     9,
      -1,    -1,    12,    13,    14,    15,    16,    17,    18,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,     3,    -1,     5,     6,     7,     8,     9,    -1,
      -1,    -1,     3,    -1,     5,     6,     7,     8,     9,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    22,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,     3,    -1,     5,     6,     7,     8,     9,     3,    -1,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,    28,    22,    30,    31,
      -1,    -1,    -1,    28,    29,    30,    31,     3,    -1,     5,
       6,     7,     8,     9,    -1,    -1,    -1,     3,    -1,     5,
       6,     7,    -1,     9,    -1,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    28,    29,    30,    31,    22,    -1,    -1,    -1,
      -1,    -1,    28,    29,    30,    31,     3,    -1,     5,     6,
       7,     8,     9,     3,    -1,     5,     6,     7,     3,     9,
       5,     6,     7,    -1,     9,    22,    23,    -1,    -1,    -1,
      -1,    28,    22,    -1,    31,    -1,    -1,    22,    28,    -1,
      30,    31,    -1,    28,    -1,     3,    31,     5,     6,     7,
      -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,
      28
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    35,     0,     1,     3,     5,     6,     7,     9,    12,
      13,    14,    15,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    36,    37,    48,    53,    54,    55,    56,
      59,     8,    31,    57,     3,     5,     6,     7,     9,    10,
      11,    22,    28,    29,    30,    31,    48,    50,    51,    52,
      60,    10,    11,    50,    33,     3,    50,    49,    50,    49,
      49,    16,    17,    18,    38,     8,    55,     8,    31,    56,
      59,    61,    64,    65,    73,    57,     8,     8,     3,    48,
       8,    51,    23,     8,     8,     8,     3,     4,     8,     8,
       8,     8,     8,    50,     3,     3,    42,    30,    65,    70,
      71,    72,    65,    29,    30,    58,    31,    52,    60,    62,
      63,    66,    74,    52,    49,     3,    22,    46,    47,     8,
       8,     8,    19,    20,    44,    29,    72,    61,    30,    66,
      67,    68,    69,    66,    30,    58,    34,    29,    29,    30,
      39,    40,    41,    50,     8,    21,    29,    69,    62,     8,
      49,    49,     3,    22,    35,    35,    35,     8,    45,     8,
      34,    34,    29,    43,    35,     8,     8,    49,    35,    34,
       8
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;
/* Location data for the look-ahead symbol.  */
YYLTYPE yylloc;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[2];

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;
#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
	YYSTACK_RELOCATE (yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 115 "tadd.y"
    { lex_sync (); define_func_flag = 1; cdll_head = NULL; ;}
    break;

  case 3:
#line 116 "tadd.y"
    { lex_sync (); define_func_flag = 0; cdll_head = NULL; ;}
    break;

  case 4:
#line 119 "tadd.y"
    { NULLIFY ((yyval)); ;}
    break;

  case 5:
#line 120 "tadd.y"
    { NULLIFY ((yyval)); ;}
    break;

  case 6:
#line 124 "tadd.y"
    {
	  fprintf (yyout, "@\"cond id='F%d_%d'\"\n", idnum, id_counter);
	  id_counter++;
      ;}
    break;

  case 7:
#line 129 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(5) - (6)]).offset, (yyvsp[(6) - (6)]).offset);
	  char *xml  = str_to_xml2 (text);

	  fprintf (yyout, "%s%s\n", (yyvsp[(5) - (6)]).str, text);
	  fprintf (yyout, "%s%s%s", (yyvsp[(2) - (6)]).tadd, (yyvsp[(3) - (6)]).tadd, (yyvsp[(4) - (6)]).tadd);
	  fprintf (yyout, "@\"endif id='F%d_%d' dir='%s%s' " LINE_FMT "/\"\n",
		   idnum, id_counter, (yyvsp[(5) - (6)]).str, xml, LINE_INFO((yylsp[(5) - (6)])));
	  fprintf (yyout, "@\"/cond\"\n");

	  id_counter++;
	  free_lval (&(yyvsp[(2) - (6)])); free_lval (&(yyvsp[(3) - (6)])); free_lval (&(yyvsp[(4) - (6)])); 
	  EFREE ((yyvsp[(5) - (6)]).str); EFREE (text); EFREE (xml);
	  NULLIFY((yyval));
      ;}
    break;

  case 8:
#line 145 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml = str_to_xml2 (text);
	  fprintf (yyout, "@\"include id='F%d_%d' dir='%s' type='system' "
		   "file='%s' " LINE_FMT "\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);
	  fprintf (yyout, "@\"/include\"\n");

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE ((yyvsp[(1) - (3)]).str); EFREE (text); EFREE (xml);
	  NULLIFY((yyval));
      ;}
    break;

  case 9:
#line 159 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml = str_to_xml2 (text);
	  fprintf (yyout, "@\"include id='F%d_%d' dir='%s' type='user' "
		   "file='%s' " LINE_FMT "\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);
	  fprintf (yyout, "@\"/include\"\n");

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE ((yyvsp[(1) - (3)]).str); EFREE (text); EFREE (xml);
	  NULLIFY((yyval));
      ;}
    break;

  case 10:
#line 173 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "@\"include id='F%d_%d' dir='%s' type='pp_tokens' "
		   "file='%s' " LINE_FMT "\"\n"
		   "@\"exp orig='%s'\"%s@\"/exp\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)),
		   (yyvsp[(2) - (3)]).str, (yyvsp[(2) - (3)]).tadd);
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);
	  fprintf (yyout, "@\"/include\"\n");

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE ((yyvsp[(1) - (3)]).str); EFREE (text); EFREE (xml);
	  NULLIFY((yyval));
      ;}
    break;

  case 11:
#line 189 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "@\"include_next id='F%d_%d' dir='%s' type='system' "
		   "file='%s' " LINE_FMT "\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);
	  fprintf (yyout, "@\"/include_next\"\n");

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE ((yyvsp[(1) - (3)]).str); EFREE (text); EFREE (xml);
	  NULLIFY((yyval));
      ;}
    break;

  case 12:
#line 203 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "@\"include_next id='F%d_%d' dir='%s' type='user' "
		   "file='%s' " LINE_FMT "\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);
	  fprintf (yyout, "@\"/include_next\"\n");

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE ((yyvsp[(1) - (3)]).str); EFREE (text); EFREE (xml);
	  NULLIFY((yyval));
      ;}
    break;

  case 13:
#line 217 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout,
		   "@\"include_next id='F%d_%d' dir='%s' type='pp_tokens' "
		   "file='%s' " LINE_FMT "\"\n"
		   "@\"exp orig='%s'\"%s@\"/exp\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)),
		   (yyvsp[(2) - (3)]).str, (yyvsp[(2) - (3)]).tadd);
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);
	  fprintf (yyout, "@\"/include_next\"\n");

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE ((yyvsp[(1) - (3)]).str); EFREE (text); EFREE (xml);
	  NULLIFY((yyval));
      ;}
    break;

  case 14:
#line 234 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(3) - (6)]).offset, (yyvsp[(6) - (6)]).offset);
	  char *xml  = str_to_xml2 (text);

	  fprintf (yyout, "@\"define type='obj' id='F%d_%d' dir='%s' "
		   "name='%s' macro_body='%s' " LINE_FMT "/\"\n",
		   idnum, id_counter, (yyvsp[(1) - (6)]).str, (yyvsp[(3) - (6)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s%s\n", (yyvsp[(1) - (6)]).str, (yyvsp[(3) - (6)]).str, text); 
	  fprintf (yyout, "#ifndef %s\n", (yyvsp[(3) - (6)]).str2);
	  fprintf (yyout, "#define %s @\"macro_body ref='F%d_%d'\"%s@\"/macro_body\"\n",
		   (yyvsp[(3) - (6)]).str2, idnum, id_counter, (yyvsp[(4) - (6)]).tadd); 
	  fprintf (yyout, "#endif\n");
	  output_check_def_macro ((yyvsp[(3) - (6)]).str, 1);
	  
	  id_counter++; free_lval (&(yyvsp[(3) - (6)])); free_lval (&(yyvsp[(4) - (6)]));
	  EFREE ((yyvsp[(1) - (6)]).str); EFREE (text); EFREE (xml);
	  NULLIFY((yyval));
      ;}
    break;

  case 15:
#line 254 "tadd.y"
    { 
	  char *text, *text2, *xml, *xml2;
	  char *id2 = estrdup ((yyvsp[(3) - (8)]).str);
	  char *double2 = estrdup ((yyvsp[(3) - (8)]).str2);
	  chop (id2); chop (double2);

	  text = get_text ((yyvsp[(5) - (8)]).offset, (yyvsp[(8) - (8)]).offset);
	  xml  = str_to_xml2 (text);

	  text2 = get_text ((yyvsp[(3) - (8)]).offset, (yyvsp[(5) - (8)]).offset);
	  chop_char (text2, ')');
	  xml2 = str_to_xml2 (text2);

	  fprintf (yyout, "@\"define type='func' id='F%d_%d' dir='%s' "
		   "name='%s' args='%s' macro_body='%s' " LINE_FMT "\"\n",
		   idnum, id_counter, (yyvsp[(1) - (8)]).str, id2, xml2, xml, LINE_INFO((yyloc)));
	  output_params ((yyvsp[(4) - (8)]).list);
	  fprintf (yyout, "@\"/define\"\n");
          fprintf (yyout, "%s%s%s)%s\n",
		   (yyvsp[(1) - (8)]).str, (yyvsp[(3) - (8)]).str, text2, text);

	  fprintf (yyout, "#ifndef %s\n", double2);
	  fprintf (yyout, "#define %s%s%s%s) @\"macro_body ref='F%d_%d'\"",
		   (yyvsp[(3) - (8)]).str2, (yyvsp[(4) - (8)]).str, ((!strcmp ((yyvsp[(4) - (8)]).str, "")) ? "" : ", "),
		   (yyvsp[(4) - (8)]).str2, idnum, id_counter);
	  output_params2 ((yyvsp[(4) - (8)]).list);
	  fprintf (yyout, "%s@\"/macro_body\"\n", (yyvsp[(6) - (8)]).tadd);
	  fprintf (yyout, "#endif\n");
	  output_check_def_macro (id2, 1);

          id_counter++; free_lval (&(yyvsp[(3) - (8)])); free_lval2 (&(yyvsp[(4) - (8)])); free_lval (&(yyvsp[(6) - (8)]));
	  EFREE ((yyvsp[(1) - (8)]).str); EFREE (id2); EFREE (double2);
	  EFREE (text); EFREE (xml); EFREE (text2); EFREE (xml2);
	  NULLIFY((yyval));
      ;}
    break;

  case 16:
#line 291 "tadd.y"
    { 
	  char *text, *text2, *xml, *xml2;
	  char *id2 = estrdup ((yyvsp[(3) - (8)]).str);
	  char *double2 = estrdup ((yyvsp[(3) - (8)]).str2);
	  chop (id2); chop (double2);

	  text = get_text ((yyvsp[(5) - (8)]).offset, (yyvsp[(8) - (8)]).offset);
	  xml = str_to_xml2 (text);

	  text2 = get_text ((yyvsp[(3) - (8)]).offset, (yyvsp[(5) - (8)]).offset);
	  chop_char (text2, ')');
	  xml2 = str_to_xml2 (text2);

	  fprintf (yyout, "@\"define type='func_variadic' id='F%d_%d' "
		   "dir='%s' name='%s' args='%s' macro_body='%s' "
		   LINE_FMT "/\"\n",
		   idnum, id_counter, (yyvsp[(1) - (8)]).str, id2, xml2, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s%s) %s\n",
		   (yyvsp[(1) - (8)]).str, (yyvsp[(3) - (8)]).str, text2, text);

	  fprintf (yyout, "#ifndef %s\n", double2);
	  fprintf (yyout, "#define %s...) @\"macro_body ref='F%d_%d'\""
		   "@\"param name='__VA_ARGS__'\"(__VA_ARGS__)@\"/param\""
		   "TBCPPA_APPLY(%s, TBCPPA_FIRST_HALF_ARGS(__VA_ARGS__))"
		   "@\"/macro_body\"\n",
		   (yyvsp[(3) - (8)]).str2, idnum, id_counter, id2);
	  fprintf (yyout, "#endif\n");
	  output_check_def_macro (id2, 1);

	  id_counter++; free_lval (&(yyvsp[(3) - (8)])); free_lval (&(yyvsp[(6) - (8)]));
	  EFREE ((yyvsp[(1) - (8)]).str); EFREE (id2); EFREE (double2);
	  EFREE (text); EFREE (xml); EFREE (text2); EFREE (xml2);
      ;}
    break;

  case 17:
#line 326 "tadd.y"
    {
	  char *text, *text2, *xml, *xml2;
	  char *id2 = estrdup ((yyvsp[(3) - (10)]).str);
	  char *double2 = estrdup ((yyvsp[(3) - (10)]).str2);
	  chop (id2); chop (double2);

	  text = get_text ((yyvsp[(7) - (10)]).offset, (yyvsp[(10) - (10)]).offset);
	  xml  = str_to_xml2 (text);

	  text2 = get_text ((yyvsp[(3) - (10)]).offset, (yyvsp[(7) - (10)]).offset);
	  chop_char (text2, ')');
	  xml2 = str_to_xml2 (text2);

	  fprintf (yyout, "@\"define type='func_variadic' id='F%d_%d' "
		   "dir='%s' name='%s' args='%s' macro_body='%s' "
		   LINE_FMT "\"\n",
		   idnum, id_counter, (yyvsp[(1) - (10)]).str, id2, xml2, xml, LINE_INFO((yyloc)));
	  output_params ((yyvsp[(4) - (10)]).list);
	  fprintf (yyout, "@\"/define\"\n");
	  fprintf (yyout, "%s%s%s) %s\n",
		   (yyvsp[(1) - (10)]).str, (yyvsp[(3) - (10)]).str,  text2, text);

	  fprintf (yyout, "#ifndef %s\n", double2);
	  fprintf (yyout,
		   "#define %s%s,...) @\"macro_body ref='F%d_%d'\"",
		   (yyvsp[(3) - (10)]).str2, (yyvsp[(4) - (10)]).str, idnum, id_counter);
	  output_params2 ((yyvsp[(4) - (10)]).list);
	  fprintf (yyout,
		   "@\"param name='__VA_ARGS__'\"(__VA_ARGS__)@\"/param\""
		   "TBCPPA_APPLY(%s, TBCPPA_FIRST_HALF_ARGS(%s, __VA_ARGS__))"
		   "@\"/macro_body\"\n", id2, (yyvsp[(4) - (10)]).str);
	  fprintf (yyout, "#endif\n");
	  output_check_def_macro (id2, 1);

	  id_counter++; free_lval (&(yyvsp[(3) - (10)])); free_lval2 (&(yyvsp[(4) - (10)])); free_lval (&(yyvsp[(8) - (10)]));
	  EFREE ((yyvsp[(1) - (10)]).str); EFREE (id2); EFREE (double2);
	  EFREE (text); EFREE (xml); EFREE (text2); EFREE (xml2);
	  NULLIFY((yyval));
      ;}
    break;

  case 18:
#line 366 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(2) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);

	  fprintf (yyout, "@\"undef id='F%d_%d' dir='%s' name='%s%s' "
		   LINE_FMT "/\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, (yyvsp[(2) - (3)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s%s\n", (yyvsp[(1) - (3)]).str, (yyvsp[(2) - (3)]).str, text);
	  fprintf (yyout, "#undef %s\n", (yyvsp[(2) - (3)]).str2);
	  output_check_def_macro ((yyvsp[(2) - (3)]).str, 0);

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE ((yyvsp[(1) - (3)]).str); EFREE (text); EFREE (xml);
	  NULLIFY((yyval));
      ;}
    break;

  case 19:
#line 382 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "@\"other_cpp_directive type='line' id='F%d_%d' "
		   "dir='%s%s' " LINE_FMT "/\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE (text); EFREE (xml); EFREE ((yyvsp[(1) - (3)]).str);
	  NULLIFY((yyval));
      ;}
    break;

  case 20:
#line 395 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "@\"other_cpp_directive type='error' id='F%d_%d' "
		   "dir='%s%s' " LINE_FMT "/\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE (text); EFREE (xml); EFREE ((yyvsp[(1) - (3)]).str);
	  NULLIFY((yyval));
      ;}
    break;

  case 21:
#line 408 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "@\"other_cpp_directive type='pragma' id='F%d_%d' "
		   "dir='%s%s' " LINE_FMT "/\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE (text); EFREE (xml); EFREE ((yyvsp[(1) - (3)]).str);
	  NULLIFY((yyval));
      ;}
    break;

  case 22:
#line 421 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "@\"other_cpp_directive type='empty' id='F%d_%d' "
		   "dir='%s%s' " LINE_FMT "/\"\n",
		   idnum, id_counter, (yyvsp[(1) - (3)]).str, xml, LINE_INFO((yyloc)));
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);

	  id_counter++; free_lval (&(yyvsp[(2) - (3)]));
	  EFREE (text); EFREE (xml); EFREE ((yyvsp[(1) - (3)]).str);
	  NULLIFY((yyval));
      ;}
    break;

  case 23:
#line 434 "tadd.y"
    {
	  fprintf (yyout, "%s\n", (yyvsp[(1) - (2)]).tadd);
	  free_lval (&(yyvsp[(1) - (2)]));
	  NULLIFY((yyval));
      ;}
    break;

  case 24:
#line 440 "tadd.y"
    {
	  yyerrok;
	  fprintf (yyout, "/* error recovery (F%d:%d.%d-%d.%d) */\n",
		   LINE_INFO((yyloc)));
	  output_error_text (LINE_INFO((yyloc)));
	  fprintf (yyout, "/* end of error recovery */\n");
	  NULLIFY((yyval));
      ;}
    break;

  case 25:
#line 452 "tadd.y"
    { 
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml = str_to_xml2 (text);
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);
          fprintf (yyout, "@\"cond_selected type='if' ref='F%d_%d' "
		   LINE_FMT "\"\n", idnum, id_counter, LINE_INFO2((yylsp[(1) - (3)]),(yylsp[(3) - (3)])));
	  fprintf (yyout, "@\"exp orig='%s'\"%s@\"/exp\"\n",
		   xml, (yyvsp[(2) - (3)]).tadd);
	  (yyval).str  = (char *)id_counter++; 
	  (yyval).str2 = (char *)xml;
	  EFREE (text);
      ;}
    break;

  case 26:
#line 465 "tadd.y"
    {
	  NULLIFY ((yyval));
	  easprintf (&(yyval).tadd,
		     "@\"if id='F%d_%d' dir='%s' exp='%s' " LINE_FMT "/\"\n",
		     idnum, (int)(yyvsp[(4) - (5)]).str, (yyvsp[(1) - (5)]).str, (char *)(yyvsp[(4) - (5)]).str2,
		     LINE_INFO((yyloc)));
	  fprintf (yyout, "@\"/cond_selected\"\n");
	  free_lval (&(yyvsp[(2) - (5)]));
	  EFREE ((yyvsp[(1) - (5)]).str);
	  EFREE ((char *)(yyvsp[(4) - (5)]).str2);
      ;}
    break;

  case 27:
#line 477 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "%s%s\n",  (yyvsp[(1) - (3)]).str, text);
          fprintf (yyout, "@\"cond_selected type='ifdef' ref='F%d_%d' "
		   LINE_FMT "\"\n", idnum, id_counter, LINE_INFO2((yylsp[(1) - (3)]),(yylsp[(3) - (3)])));
	  fprintf (yyout, "@\"exp orig='%s'\"%s@\"/exp\"\n",
		   xml, (yyvsp[(2) - (3)]).tadd);
	  (yyval).str  = (char *)id_counter++; 
	  (yyval).str2 = (char *)xml;
	  EFREE (text);
      ;}
    break;

  case 28:
#line 490 "tadd.y"
    {
	  NULLIFY ((yyval));
	  easprintf (&(yyval).tadd, "@\"ifdef id='F%d_%d' dir='%s' exp='%s' "
		     LINE_FMT "/\"\n",
		     idnum, (int)(yyvsp[(4) - (5)]).str, (yyvsp[(1) - (5)]).str, (char *)(yyvsp[(4) - (5)]).str2,
		     LINE_INFO((yyloc)));
	  fprintf (yyout, "@\"/cond_selected\"\n");
	  EFREE ((yyvsp[(1) - (5)]).str);
	  EFREE ((char *)(yyvsp[(4) - (5)]).str2);
	  free_lval (&(yyvsp[(2) - (5)]));
      ;}
    break;

  case 29:
#line 502 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (3)]).offset, (yyvsp[(3) - (3)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (3)]).str, text);
          fprintf (yyout, "@\"cond_selected type='ifndef' ref='F%d_%d' "
		   LINE_FMT "\"\n", idnum, id_counter, LINE_INFO2((yylsp[(1) - (3)]), (yylsp[(3) - (3)])));
	  fprintf (yyout, "@\"exp orig='%s'\"%s@\"/exp\"\n",
		   xml, (yyvsp[(2) - (3)]).tadd);
	  (yyval).str  = (char *)id_counter++; 
	  (yyval).str2 = (char *)xml;
	  EFREE (text);
      ;}
    break;

  case 30:
#line 515 "tadd.y"
    {
	  NULLIFY ((yyval));
	  easprintf (&(yyval).tadd, "@\"ifndef id='F%d_%d' dir='%s' exp='%s' "
		     LINE_FMT "/\"\n",
		     idnum, (int)(yyvsp[(4) - (5)]).str, (yyvsp[(1) - (5)]).str, (char *)(yyvsp[(4) - (5)]).str2,
		     LINE_INFO((yyloc)));
	  fprintf (yyout, "@\"/cond_selected\"\n");
	  EFREE ((yyvsp[(1) - (5)]).str);
	  EFREE ((char *)(yyvsp[(4) - (5)]).str2);
	  free_lval (&(yyvsp[(2) - (5)]));
      ;}
    break;

  case 31:
#line 530 "tadd.y"
    {
	  NULLIFY ((yyval));
	  (yyval).tadd = estrdup ("");
      ;}
    break;

  case 32:
#line 535 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(2) - (4)]).offset, (yyvsp[(4) - (4)]).offset);
	  char *xml  = str_to_xml2 (text);
	  fprintf (yyout, "%s%s\n", (yyvsp[(2) - (4)]).str, text);
          fprintf (yyout, "@\"cond_selected type='elif' ref='F%d_%d' "
		   LINE_FMT "\"\n", idnum, id_counter, LINE_INFO2((yylsp[(2) - (4)]),(yylsp[(4) - (4)])));
	  fprintf (yyout, "@\"exp orig='%s'\"%s@\"/exp\"\n",
		   xml, (yyvsp[(3) - (4)]).tadd);
	  (yyval).str  = (char *)id_counter++; 
	  (yyval).str2 = (char *)xml;
	  EFREE (text);
      ;}
    break;

  case 33:
#line 548 "tadd.y"
    {
	  NULLIFY ((yyval));
	  easprintf (&(yyval).tadd,
		     "%s@\"elif id='F%d_%d' dir='%s' exp='%s' "
		     LINE_FMT "/\"\n",
		     (yyvsp[(1) - (6)]).tadd, idnum, (int)(yyvsp[(5) - (6)]).str, (yyvsp[(2) - (6)]).str, (char *)(yyvsp[(5) - (6)]).str2,
		     LINE_INFO((yyloc)));
	  fprintf (yyout, "@\"/cond_selected\"\n");
	  free_lval (&(yyvsp[(1) - (6)])); free_lval (&(yyvsp[(3) - (6)]));
	  EFREE ((yyvsp[(2) - (6)]).str); EFREE ((char *)(yyvsp[(5) - (6)]).str2);
      ;}
    break;

  case 34:
#line 563 "tadd.y"
    {
	  NULLIFY ((yyval));
	  (yyval).tadd = estrdup ("");
      ;}
    break;

  case 35:
#line 568 "tadd.y"
    {
	  char *text = get_text ((yyvsp[(1) - (2)]).offset, (yyvsp[(2) - (2)]).offset);
	  char *xml = str_to_xml2 (text);
	  fprintf (yyout, "%s%s\n", (yyvsp[(1) - (2)]).str, text);
          fprintf (yyout, "@\"cond_selected type='else' ref='F%d_%d' "
		   LINE_FMT "\"\n", idnum, id_counter, LINE_INFO2((yylsp[(1) - (2)]),(yylsp[(2) - (2)])));
	  (yyval).str  = (char *)id_counter++; 
	  (yyval).str2 = (char *)xml;
	  EFREE (text);
      ;}
    break;

  case 36:
#line 579 "tadd.y"
    {
	  NULLIFY ((yyval));
	  easprintf (&(yyval).tadd, "@\"else id='F%d_%d' dir='%s%s' " 
		     LINE_FMT "/\"\n",
		     idnum, (int)(yyvsp[(3) - (4)]).str, (yyvsp[(1) - (4)]).str, (char *)(yyvsp[(3) - (4)]).str2,
		     LINE_INFO((yyloc)));
	  fprintf (yyout, "@\"/cond_selected\"\n");
	  EFREE ((yyvsp[(1) - (4)]).str); EFREE ((char *)(yyvsp[(3) - (4)]).str2);
      ;}
    break;

  case 37:
#line 592 "tadd.y"
    {
	  (yyval).str  = estrdup ("");
	  (yyval).str2 = estrdup ("");
	  (yyval).tadd = NULL;
	  (yyval).list = emalloc (sizeof (struct CDLL));
	  CDLL_init ((yyval).list);
	  cdll_head = (yyval).list;
      ;}
    break;

  case 38:
#line 601 "tadd.y"
    {
	  (yyval).str  = (yyvsp[(1) - (1)]).str;
	  (yyval).str2 = (yyvsp[(1) - (1)]).str2;
	  (yyval).tadd = NULL;
	  (yyval).list = (yyvsp[(1) - (1)]).list;
	  (yyvsp[(1) - (1)]).list = NULL;
	  cdll_head = (yyval).list;
      ;}
    break;

  case 39:
#line 613 "tadd.y"
    {
	  (yyval).str  = estrdup ((yyvsp[(1) - (1)]).str);
	  (yyval).str2 = estrdup ((yyvsp[(1) - (1)]).str2);
	  (yyval).tadd = NULL;
	  (yyval).list = emalloc (sizeof (struct CDLL));
	  CDLL_init ((yyval).list); 
	  CDLL_insert ((yyval).list, estrdup ((yyvsp[(1) - (1)]).str));
	  free_lval (&(yyvsp[(1) - (1)]));
      ;}
    break;

  case 40:
#line 623 "tadd.y"
    {
	  easprintf (&(yyval).str,  "%s, %s", (yyvsp[(1) - (3)]).str,  (yyvsp[(3) - (3)]).str);
	  easprintf (&(yyval).str2, "%s, %s", (yyvsp[(1) - (3)]).str2, (yyvsp[(3) - (3)]).str2);
	  (yyval).tadd = NULL;
	  (yyval).list = (yyvsp[(1) - (3)]).list;
	  CDLL_insert ((yyval).list, estrdup ((yyvsp[(3) - (3)]).str));
	  free_lval (&(yyvsp[(1) - (3)])); free_lval (&(yyvsp[(3) - (3)]));
      ;}
    break;

  case 41:
#line 635 "tadd.y"
    {
	  (yyval).str  = (yyvsp[(1) - (1)]).str;
	  (yyval).str2 = (yyvsp[(1) - (1)]).str2;

	  if (!strcmp ((yyvsp[(1) - (1)]).str, "defined") && is_if_or_elif) {
	      /* '(' doesn't have to follow 'defined'  */
	      (yyval).tadd = estrdup ((yyvsp[(1) - (1)]).str);
	  } else if (define_func_flag) {
	      if (CDLL_query (cdll_head, (yyvsp[(1) - (1)]).str) != -1
		  || !strcmp ((yyvsp[(1) - (1)]).str, "__VA_ARGS__")) {
		  /* a parameter in function-like macro */
		  easprintf (&(yyval).tadd, 
			     "@\"macro_call type='param' name='%s' "
			     LINE_FMT "\""
			     "@\"is_defined\"1@\"/is_defined\""
			     "@\"bare\"%s@\"/bare\" @\"double\"%s@\"/double\""
			     "@\"/macro_call\"",
			     (yyvsp[(1) - (1)]).str, LINE_INFO((yylsp[(1) - (1)])), (yyvsp[(1) - (1)]).str,
			     ((!strcmp ((yyvsp[(1) - (1)]).str, "__VA_ARGS__")) ?
			      (yyvsp[(1) - (1)]).str: (yyvsp[(1) - (1)]).str2));
	      } else {
		  easprintf (&(yyval).tadd, 
			     "@\"macro_call type='obj' name='%s' "
			     LINE_FMT "\""
			     "@\"is_defined\"%s%s@\"/is_defined\""
			     "@\"bare\"%s@\"/bare\" @\"double\"%s@\"/double\""
			     "@\"/macro_call\"",
			     (yyvsp[(1) - (1)]).str, LINE_INFO((yylsp[(1) - (1)])),
			     (yyvsp[(1) - (1)]).str, args.check_def_suffix,
			     (yyvsp[(1) - (1)]).str, (yyvsp[(1) - (1)]).str2);
	      }
	  } else {
	      easprintf (&(yyval).tadd, 
			 "@\"macro_call type='obj' name='%s' " LINE_FMT "\""
			 "@\"is_defined\""
			 "\n#ifdef %s\n1\n#else\n0\n#endif\n"
			 "@\"/is_defined\""
			 "@\"bare\"%s@\"/bare\" @\"double\"%s@\"/double\""
			 "@\"/macro_call\"",
			 (yyvsp[(1) - (1)]).str, LINE_INFO((yylsp[(1) - (1)])),
			 (yyvsp[(1) - (1)]).str, (yyvsp[(1) - (1)]).str, (yyvsp[(1) - (1)]).str2);
	  }

	  EFREE ((yyvsp[(1) - (1)]).tadd);
	  NULLIFY ((yyvsp[(1) - (1)]));
      ;}
    break;

  case 42:
#line 685 "tadd.y"
    { BOTTOM((yyval), ""); ;}
    break;

  case 43:
#line 686 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)]));   ;}
    break;

  case 44:
#line 690 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)]));   ;}
    break;

  case 45:
#line 692 "tadd.y"
    {
	  MOVE2_FMT((yyval), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]), "%s %s");
      ;}
    break;

  case 46:
#line 698 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 47:
#line 699 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 48:
#line 700 "tadd.y"
    { BOTTOM((yyval), yytext);;}
    break;

  case 49:
#line 701 "tadd.y"
    { BOTTOM((yyval), yytext);;}
    break;

  case 50:
#line 702 "tadd.y"
    { BOTTOM((yyval), yytext); ;}
    break;

  case 51:
#line 707 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 52:
#line 708 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 53:
#line 709 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 54:
#line 710 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 55:
#line 711 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 56:
#line 712 "tadd.y"
    { BOTTOM((yyval), yytext);;}
    break;

  case 57:
#line 714 "tadd.y"
    {
	  /* eliminate tracers for #'s operands */
	  easprintf (&(yyval).str,  "#%s", (yyvsp[(2) - (2)]).str);
	  easprintf (&(yyval).str2, "#%s", (yyvsp[(2) - (2)]).str2);
	  easprintf (&(yyval).tadd, "#%s", (yyvsp[(2) - (2)]).str); /* $2.str, not $2.tadd */
	  free_lval (&(yyvsp[(2) - (2)]));
      ;}
    break;

  case 58:
#line 723 "tadd.y"
    {
	  /* eliminate tracers for ##'s operands */
	  easprintf (&(yyval).str,  "%s##%s", (yyvsp[(1) - (3)]).str,  (yyvsp[(3) - (3)]).str);
	  easprintf (&(yyval).str2, "%s##%s", (yyvsp[(1) - (3)]).str2, (yyvsp[(3) - (3)]).str2);
	  easprintf (&(yyval).tadd, "%s##%s", (yyvsp[(1) - (3)]).str,  (yyvsp[(3) - (3)]).str); /* str, not tadd */
	  free_lval (&(yyvsp[(1) - (3)])); free_lval (&(yyvsp[(3) - (3)]));
      ;}
    break;

  case 59:
#line 733 "tadd.y"
    { BOTTOM((yyval), ""); ;}
    break;

  case 60:
#line 734 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 61:
#line 738 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 62:
#line 739 "tadd.y"
    { MOVE2_FMT((yyval), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]), "%s %s"); ;}
    break;

  case 63:
#line 743 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 64:
#line 744 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 65:
#line 745 "tadd.y"
    { BOTTOM((yyval), yytext); ;}
    break;

  case 66:
#line 746 "tadd.y"
    { BOTTOM((yyval), yytext); ;}
    break;

  case 67:
#line 747 "tadd.y"
    { BOTTOM((yyval), yytext); ;}
    break;

  case 68:
#line 752 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 69:
#line 753 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 70:
#line 754 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 71:
#line 755 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 72:
#line 756 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 73:
#line 757 "tadd.y"
    { BOTTOM((yyval), yytext); ;}
    break;

  case 74:
#line 758 "tadd.y"
    { BOTTOM((yyval), yytext); ;}
    break;

  case 75:
#line 759 "tadd.y"
    { BOTTOM((yyval), yytext); ;}
    break;

  case 76:
#line 764 "tadd.y"
    {
	  assert (yychar == YYEMPTY);
	  func_mc_nest++;
	  (yyval).offset = (yyvsp[(1) - (1)]).offset;
      ;}
    break;

  case 77:
#line 773 "tadd.y"
    {
	  assert (yychar == YYEMPTY);
	  func_mc_nest--;
	  assert (func_mc_nest >= 0);
	  (yyval).offset = (yyvsp[(1) - (1)]).offset;
      ;}
    break;

  case 78:
#line 785 "tadd.y"
    {
	  char *text  = get_text ((yyvsp[(2) - (4)]).offset, (yyvsp[(4) - (4)]).offset);
	  char *xml   = str_to_xml2 (chop_char (text, ')'));
	  char *text2 = get_text ((yyvsp[(1) - (4)]).offset, (yyvsp[(2) - (4)]).offset);
	  char *xml2  = str_to_xml2 (chop_char (text2, '('));

	  easprintf(&(yyval).str,  "%s%s(%s)", (yyvsp[(1) - (4)]).str, text2, (yyvsp[(3) - (4)]).str);
	  easprintf(&(yyval).str2, "%s(%s%s%s)", (yyvsp[(1) - (4)]).str2, (yyvsp[(3) - (4)]).str, 
		    ((!strcmp((yyvsp[(3) - (4)]).str, "")) ? "" : ", "), (yyvsp[(3) - (4)]).str2);

	  if (!strcmp ((yyvsp[(1) - (4)]).str, "_Pragma")) {
	      (yyval).tadd = estrdup ((yyval).str);
	  } else if (!strcmp ((yyvsp[(1) - (4)]).str, "defined") && is_if_or_elif) {
	      easprintf(&(yyval).tadd,
			"@\"macro_call type='defined' name='%s%s' args='%s' "
			LINE_FMT "\""
			"@\"is_defined\"1@\"/is_defined\""
			"@\"bare\"\n#ifdef %s\n1\n#else\n0\n#endif\n@\"/bare\""
			"@\"double\"%s@\"/double\""
			"@\"/macro_call\"",
			(yyvsp[(1) - (4)]).str, xml2, xml, LINE_INFO((yyloc)), (yyvsp[(3) - (4)]).str, (yyvsp[(3) - (4)]).tadd);
	  } else {
	      char *tadd1, *tadd2, *tadd3, *tadd4;

	      easprintf (&tadd1,
			 "@\"macro_call type='func' name='%s%s' args='%s' "
			 LINE_FMT "\"", (yyvsp[(1) - (4)]).str, xml2, xml, LINE_INFO((yyloc)));

	      if (define_func_flag) {
		  easprintf (&tadd2,
			     "@\"is_defined\"%s%s@\"/is_defined\"",
			     (yyvsp[(1) - (4)]).str, args.check_def_suffix);
	      } else {
		  easprintf (&tadd2,
			     "@\"is_defined\""
			     "\n#ifdef %s\n1\n#else\n0\n#endif\n"
			     "@\"/is_defined\"",
			     (yyvsp[(1) - (4)]).str);
	      }

	      easprintf (&tadd3, "@\"bare\"%s%s(%s)@\"/bare\"",
			 (yyvsp[(1) - (4)]).str, text2, text);

	      if (args.conservative) {
		  easprintf (&tadd4,
			     "@\"double\"%s(%s)@\"/double\"", (yyvsp[(1) - (4)]).str, (yyvsp[(3) - (4)]).str2);
	      } else {
		  easprintf (&tadd4,
			     "@\"double\"%s(%s%s%s)@\"/double\"",
			     (yyvsp[(1) - (4)]).str2, (yyvsp[(3) - (4)]).str,
			     ((!strcmp((yyvsp[(3) - (4)]).str, "")) ? "" : ", "), (yyvsp[(3) - (4)]).tadd);
	      }

	      easprintf (&(yyval).tadd, "%s%s%s%s" "@\"/macro_call\"",
			 tadd1, tadd2, tadd3, tadd4);
	      EFREE (tadd1); EFREE (tadd2); EFREE (tadd3); EFREE (tadd4);
	  }

	  id_counter++; free_lval (&(yyvsp[(1) - (4)])); free_lval (&(yyvsp[(3) - (4)]));
	  EFREE (text); EFREE (xml); EFREE (text2); EFREE (xml2);
      ;}
    break;

  case 79:
#line 850 "tadd.y"
    {
	  char *text  = get_text ((yyvsp[(2) - (4)]).offset, (yyvsp[(4) - (4)]).offset);
	  char *xml   = str_to_xml2 (chop_char (text, ')'));
	  char *text2 = get_text ((yyvsp[(1) - (4)]).offset, (yyvsp[(2) - (4)]).offset);
	  char *xml2  = str_to_xml2 (chop_char (text2, '('));

	  easprintf(&(yyval).str,  "%s%s(%s)", (yyvsp[(1) - (4)]).str, text2, (yyvsp[(3) - (4)]).str);
	  easprintf(&(yyval).str2, "%s(%s%s%s)", (yyvsp[(1) - (4)]).str2, (yyvsp[(3) - (4)]).str, 
		    ((!strcmp((yyvsp[(3) - (4)]).str, "")) ? "" : ", "), (yyvsp[(3) - (4)]).str2);

	  if (!strcmp ((yyvsp[(1) - (4)]).str, "_Pragma")) {
	      (yyval).tadd = estrdup ((yyval).str);
	  } else if (!strcmp ((yyvsp[(1) - (4)]).str, "defined") && is_if_or_elif) {
	      easprintf(&(yyval).tadd,
			"@\"macro_call type='defined' name='%s%s' args='%s' "
			LINE_FMT "\""
			"@\"is_defined\"1@\"/is_defined\""
			"@\"bare\"\n#ifdef %s\n1\n#else\n0\n#endif\n@\"/bare\""
			"@\"double\"%s@\"/double\""
			"@\"/macro_call\"",
			(yyvsp[(1) - (4)]).str, xml2, xml, LINE_INFO((yyloc)), (yyvsp[(3) - (4)]).str, (yyvsp[(3) - (4)]).tadd);
	  } else {
	      char *tadd1, *tadd2, *tadd3, *tadd4;

	      easprintf (&tadd1,
			 "@\"macro_call type='func' name='%s%s' args='%s' "
			 LINE_FMT "\"", (yyvsp[(1) - (4)]).str, xml2, xml, LINE_INFO((yyloc)));

	      if (define_func_flag) {
		  easprintf (&tadd2,
			     "@\"is_defined\"%s%s@\"/is_defined\"",
			     (yyvsp[(1) - (4)]).str, args.check_def_suffix);
	      } else {
		  easprintf (&tadd2,
			     "@\"is_defined\""
			     "\n#ifdef %s\n1\n#else\n0\n#endif\n"
			     "@\"/is_defined\"",
			     (yyvsp[(1) - (4)]).str);
	      }

	      easprintf (&tadd3, "@\"bare\"%s%s(%s)@\"/bare\"",
			 (yyvsp[(1) - (4)]).str, text2, text);

	      if (args.conservative) {
		  easprintf (&tadd4,
			     "@\"double\"%s(%s)@\"/double\"", (yyvsp[(1) - (4)]).str, (yyvsp[(3) - (4)]).str2);
	      } else {
		  easprintf (&tadd4,
			     "@\"double\"%s(%s%s%s)@\"/double\"",
			     (yyvsp[(1) - (4)]).str2, (yyvsp[(3) - (4)]).str,
			     ((!strcmp((yyvsp[(3) - (4)]).str, "")) ? "" : ", "), (yyvsp[(3) - (4)]).tadd);
	      }

	      easprintf (&(yyval).tadd, "%s%s%s%s" "@\"/macro_call\"",
			 tadd1, tadd2, tadd3, tadd4);

	      EFREE (tadd1); EFREE (tadd2); EFREE (tadd3); EFREE (tadd4);
	  }

	  id_counter++; free_lval (&(yyvsp[(1) - (4)])); free_lval (&(yyvsp[(3) - (4)]));
	  EFREE (text); EFREE (xml); EFREE (text2); EFREE (xml2);
      ;}
    break;

  case 80:
#line 915 "tadd.y"
    { BOTTOM((yyval), ""); ;}
    break;

  case 81:
#line 916 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 82:
#line 920 "tadd.y"
    { BOTTOM((yyval), ""); ;}
    break;

  case 83:
#line 921 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 84:
#line 925 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 85:
#line 928 "tadd.y"
    {
	  MOVE2_FMT((yyval), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]), "%s %s");
      ;}
    break;

  case 86:
#line 934 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 87:
#line 937 "tadd.y"
    {
	  MOVE2_FMT((yyval), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]), "%s %s");
      ;}
    break;

  case 88:
#line 943 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 89:
#line 944 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 90:
#line 945 "tadd.y"
    { MOVE1_FMT((yyval), (yyvsp[(2) - (3)]), "(%s)"); ;}
    break;

  case 91:
#line 946 "tadd.y"
    { BOTTOM((yyval), ""); ;}
    break;

  case 92:
#line 950 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 93:
#line 951 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 94:
#line 952 "tadd.y"
    { MOVE1_FMT((yyval), (yyvsp[(2) - (3)]), "(%s)"); ;}
    break;

  case 95:
#line 956 "tadd.y"
    { BOTTOM((yyval), ""); ;}
    break;

  case 96:
#line 957 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 97:
#line 961 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 98:
#line 964 "tadd.y"
    {
	  MOVE2_FMT((yyval), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]), "%s %s");
      ;}
    break;

  case 99:
#line 970 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 100:
#line 971 "tadd.y"
    { BOTTOM((yyval), yytext); ;}
    break;

  case 101:
#line 975 "tadd.y"
    { BOTTOM((yyval), ""); ;}
    break;

  case 102:
#line 976 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 103:
#line 980 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 104:
#line 982 "tadd.y"
    {
	  MOVE2_FMT((yyval), (yyvsp[(1) - (2)]), (yyvsp[(2) - (2)]), "%s %s");
      ;}
    break;

  case 105:
#line 988 "tadd.y"
    { MOVE((yyval), (yyvsp[(1) - (1)])); ;}
    break;

  case 106:
#line 989 "tadd.y"
    { BOTTOM((yyval), yytext); ;}
    break;

  case 107:
#line 994 "tadd.y"
    {
	  char *xml = str_to_xml2 ((yyvsp[(1) - (1)]).str);
	  (yyval).str  = (yyvsp[(1) - (1)]).str;
	  (yyval).str2 = (yyvsp[(1) - (1)]).str2;
	  if (!strcmp ((yyvsp[(1) - (1)]).str, "")) {
	      (yyval).tadd = xml;
	  } else {
	      easprintf (&(yyval).tadd, "@\"arg exp='%s' " LINE_FMT "\"%s@\"/arg\"",
			 xml, LINE_INFO((yylsp[(1) - (1)])), (yyvsp[(1) - (1)]).tadd);
	      EFREE (xml);
	  }
	  EFREE ((yyvsp[(1) - (1)]).tadd);
	  NULLIFY ((yyvsp[(1) - (1)]));
      ;}
    break;

  case 108:
#line 1009 "tadd.y"
    {
	  char *xml = str_to_xml2 ((yyvsp[(3) - (3)]).str);
	  easprintf (&(yyval).str,  "%s, %s", (yyvsp[(1) - (3)]).str,  (yyvsp[(3) - (3)]).str);
	  easprintf (&(yyval).str2, "%s, %s", (yyvsp[(1) - (3)]).str2, (yyvsp[(3) - (3)]).str2);
	  if (!strcmp ((yyvsp[(1) - (3)]).str, "")) {
	      (yyval).tadd = xml;
	  } else {
	      easprintf (&(yyval).tadd, "%s, @\"arg exp='%s' " LINE_FMT
			 "\"%s@\"/arg\"",
			 (yyvsp[(1) - (3)]).tadd, xml, LINE_INFO((yylsp[(3) - (3)])), (yyvsp[(3) - (3)]).tadd);
	      EFREE (xml);
	  }
	  free_lval (&(yyvsp[(1) - (3)])); free_lval (&(yyvsp[(3) - (3)]));
	  NULLIFY ((yyvsp[(1) - (3)])); NULLIFY ((yyvsp[(3) - (3)]));
      ;}
    break;

  case 109:
#line 1028 "tadd.y"
    {
	  char *xml = str_to_xml2 ((yyvsp[(1) - (1)]).str);
	  (yyval).str  = (yyvsp[(1) - (1)]).str;
	  (yyval).str2 = (yyvsp[(1) - (1)]).str2;
	  if (!strcmp ((yyvsp[(1) - (1)]).str, "")) {
	      (yyval).tadd = xml;
	  } else {
	      easprintf (&(yyval).tadd, "@\"arg exp='%s' " LINE_FMT "\"%s@\"/arg\"",
			 xml, LINE_INFO((yylsp[(1) - (1)])), (yyvsp[(1) - (1)]).tadd);
	      EFREE (xml);
	  }
	  EFREE ((yyvsp[(1) - (1)]).tadd);
	  NULLIFY ((yyvsp[(1) - (1)]));
      ;}
    break;

  case 110:
#line 1043 "tadd.y"
    {
	  char *xml = str_to_xml2 ((yyvsp[(3) - (3)]).str);
	  easprintf (&(yyval).str,  "%s, %s", (yyvsp[(1) - (3)]).str,  (yyvsp[(3) - (3)]).str);
	  easprintf (&(yyval).str2, "%s, %s", (yyvsp[(1) - (3)]).str2, (yyvsp[(3) - (3)]).str2);
	  if (!strcmp ((yyvsp[(1) - (3)]).str, "")) {
	      (yyval).tadd = xml;
	  } else {
	      easprintf (&(yyval).tadd, "%s, @\"arg exp='%s' " LINE_FMT
			 "\"%s@\"/arg\"",
			 (yyvsp[(1) - (3)]).tadd, xml, LINE_INFO((yylsp[(3) - (3)])), (yyvsp[(3) - (3)]).tadd);
	      EFREE (xml);
	  }
	  free_lval (&(yyvsp[(1) - (3)])); free_lval (&(yyvsp[(3) - (3)]));
	  NULLIFY ((yyvsp[(1) - (3)])); NULLIFY ((yyvsp[(3) - (3)]));
      ;}
    break;


/* Line 1267 of yacc.c.  */
#line 2940 "tadd.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the look-ahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 1059 "tadd.y"
 /* ==================================================================== */
/* to make sure yyparse () does always fetch a look-ahead token eagerly. */
static void
lex_sync (void)
{
    if (yychar == YYEMPTY) {
        yychar = yylex ();
        /* just in case yylex returns negative to indicate EOF */
        if (yychar < 0) 
            yychar = 0; /* EOF */
    }
}

static void
free_lval (struct lval *lval)
{
    assert (lval != NULL);
    if (lval->str  != NULL) { EFREE (lval->str);  lval->str  = NULL; }
    if (lval->str2 != NULL) { EFREE (lval->str2); lval->str2 = NULL; }
    if (lval->tadd != NULL) { EFREE (lval->tadd); lval->tadd = NULL; }
}

static void
free_lval2 (struct lval *lval)
{
    assert (lval != NULL);
    free_lval (lval);
    if (lval->list != NULL) {
	CDLL_free (lval->list);
	lval->list = NULL;
    }
}

static int
yyerror (char *mesg)
{
#if 1 /* experimental error recovery */
    switch (yychar) {
    case INCLUDE: case INCLUDE_NEXT: case DEFINE: case UNDEF:
    case IF:      case IFDEF:        case IFNDEF: case ELIF:   case ELSE:
    case ENDIF:   case LINE:         case ERROR:  case PRAGMA: case EMPTY:
	tadd_unput (yytext);
	tadd_unput ("\n");
	yylloc.last_line--;
	yyclearin;
	break;
    default:
	/* do nothing */
	break;
    }
#endif

    return fprintf (stderr, "error(%d: %d.%d-%d.%d): %s\n",
		    LINE_INFO(yylloc), mesg);
}

static void
print_usage (void)
{
    fprintf (stderr, 
	     "usage  : tadd.exe [options] foo.[ch] ...\n"
	     "options:\n"
	     "    --dir         dir      output dir [./TBCppA]\n"
	     "    --db-file     file     db_flie [db_file](relative to dir)\n"
	     "    --lex-suffix suffix    suffix [.lex]\n"
	     "    --double-suffix suffix [_1528552]\n"
	     "    --check-def-suffix suffix [_3141592_is_defined]\n"
             "    --yydebug              enable bison debugging[off]\n"
	     "    --conservative         no embedding tracers to macro args\n"
	     "    --help                 prints this usage\n"
	     );
}

static void
process_options (int argc, char *argv [])
{
    int    i;
    for (i = 1; i < argc; i++) {
	if (argv [i][0] != '-') {                    /* filenames */
	    int j;
	    for (j = 0; i < argc && argv [i][0] != '-'; i++, j++) {
		args.file = erealloc (args.file, sizeof (char *) * (j + 1));
		args.file [j] = emalloc (strlen (argv [i]) + 1);
		strcpy (args.file [j], argv [i]);
	    }
	    i--;
	    args.file_num = j;
	} else if (!strcmp (argv [i], "--dir")) {
	    i++;
	    args.dir = argv [i];
	} else if (!strcmp (argv [i], "--db-file")) {
	    i++;
	    args.db_file = argv [i];
	} else if (!strcmp (argv [i], "--lex-suffix")) {
	    i++;
	    args.lex_suffix = argv [i];
	} else if (!strcmp (argv [i], "--yydebug")) {
	    yydebug = 1;
	} else if (!strcmp (argv [i], "--double-suffix")) {
	    i++;
	    args.double_suffix = argv [i];
	} else if (!strcmp (argv [i], "--check-def-suffix")) {
	    i++;
	    args.check_def_suffix = argv [i];
	} else if (!strcmp (argv [i], "--conservative")) {
	    args.conservative = 1;
	} else {
	    if (strcmp (argv [i], "--help"))
		fprintf (stderr, "unknown option: %s\n", argv [i]);
	    print_usage ();
	    exit (1);
	}
    }
}

static void
output_xml_begin (char *file)
{
    fprintf (yyout, "@@preamble %s.xml %s%s\n",
	     args.db_file, absolute_path, args.lex_suffix);
    fprintf (yyout, 
	     "@\"file id='F%d_%d' file='%s' path='%s' filename_ref='F%d'\"\n",
	     idnum, id_counter++, file, absolute_path, idnum);
}

static void
output_xml_end (void)
{
    fprintf (yyout, "@\"/file\"\n");
}

static void
output_params (struct CDLL *head)
{
    struct CDLL *p;
    for (p = head->next; p != head; p = p->next)
	fprintf (yyout, "@\"param name='%s'/\"\n", p->param_name);
}

static void
output_params2 (struct CDLL *head)
{
    struct CDLL *p;
    for (p = head->next; p != head; p = p->next)
	fprintf (yyout, "@\"param name='%s'\"%s@\"/param\"",
		 p->param_name, p->param_name);
}

static void
output_error_text (int idnum, int first_line, int first_column,
		   int last_line, int last_column)
{
    int c, line = 1, column = 0;
    FILE *fp = fopen (absolute_path, "r");
    while ((c = getc (fp)) != EOF) {
	if ((first_line < line && line < last_line)
	    || (line == first_line && column >= first_column)
	    || (line == last_line  && column < last_column)) {
	    putc (c, yyout);
	}
	if (c == '\n') {
	    line++;
	    column = 0;
	} else {
	    column++;
	}
    }
    fclose (fp);
}

static char *
get_text (int from, int to)
{
    return chop_nl (substring (directive_buf, from - 1, to - 1));
}

static void
output_check_def_macro (char *macro_name, int is_defined)
{
    char *name = estrdup (macro_name);
    sscanf (macro_name, " %s", name);
    if (is_defined)
	fprintf (yyout, "#define %s%s 1\n", name, args.check_def_suffix);
    else
	fprintf (yyout, "#undef  %s%s\n", name, args.check_def_suffix);
    EFREE (name);
}

static void
tadd (char *file)
{
    char *path, *lex, *ret;

    ret = realpath (file, absolute_path);
    if (ret == NULL) {
	perror ("realpath"); exit (1);
    }
    pi_add (file, absolute_path);
    idnum = pi_path2idnum (absolute_path);

    yyin = fopen (file, "r");
    if (yyin == NULL) {
	perror ("fopen"); return;
    }

    easprintf (&path, "%s/%s",  args.dir, absolute_path);
    easprintf (&lex, "%s/%s%s", args.dir, absolute_path, args.lex_suffix);

    yyout   = fopen_with_mkdir (path, "w");
    if (yyout == NULL) {
	perror ("fopen"); exit (1);
    }

    lexout = fopen_with_mkdir (lex, "w");
    if (lexout == NULL) {
	perror ("fopen"); exit (1);
    }

    yylloc.first_line   = yylloc.last_line   = 1;
    yylloc.first_column = yylloc.last_column = 0;
    
    output_xml_begin (file);
    yyparse ();
    output_xml_end   ();

    fclose (yyin); fclose (yyout); fclose (lexout);
    EFREE (path); EFREE (lex);
}

/* ==================================================================== */
int
main (int argc, char *argv [])
{
    int i;
    char *db_path, *dir;

#if defined(USE_TEF)
    TEF_is_in_main = 1;
#endif

    dir = getenv ("TBCPPA_DIR");
    if (dir != NULL)
	args.dir = dir;

    process_options (argc, argv);

    easprintf (&db_path, "%s/%s", args.dir, args.db_file);
    pi_init (db_path);
    EFREE (db_path);
    absolute_path = emalloc (path_max + 1); /* this must be after pi_init() */

    for (i = 0; i < args.file_num; i++) {
	tadd (args.file [i]);
    }

    pi_final ();
    EFREE (absolute_path);
    return 0;
}

#if 0
  The content of MOVE_FMT2 "%s %s" is correct?
  				     
  How about adding NEWLNIE_opt to func_macro_call?
  => It causes reduce/reduce conflict
  How about using GLR, which saves '#define FOO BAR ('
  => %glr-parser does not work with lexical tie-in.
#endif

