/* tdbxml: simple converter from db_file to db_file.xml 
   in TBCppA project: tracer-based CPP analyzer.
   Copyright (c) 2006   Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
   $Id: tdbxml.c,v 1.1 2006/06/07 09:29:20 gondow Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <sys/param.h>

#include "misc.h"

/* ==================================================================== */
/* ==================================================================== */
/* ==================================================================== */
int
main (int argc, char *argv [])
{
    char *infile, *outfile, *path_buf, *file_buf, *buf, *ret;
    FILE *fpin, *fpout;
    int  path_max, i, ret2;

    if (argc < 2) {
	fprintf (stderr, "Usage: %s db_file\n", argv [0]);
	exit (1);
    }

    infile = argv [1];
    fpin  = fopen (infile, "r");
    if (fpin == NULL) {
	fprintf (stderr, "%s: ", infile);
	perror ("fopen");
	exit (1);
    }

    easprintf (&outfile, "%s.xml", infile);
    fpout = fopen (outfile, "w");
    if (fpout == NULL) {
	fprintf (stderr, "%s: ", outfile);
	perror ("fopen");
	exit (1);
    }

#ifdef PATH_MAX
    path_max = PATH_MAX;
#else
    path_max = getconf (".", _PC_PATH_MAX);
    if (path_max < 1024)
	path_max = 1024;
#endif
    buf = emalloc ((path_max + 1) * 2);
    path_buf = emalloc (path_max + 1);
    file_buf = emalloc (path_max + 1);

    for (i = 0; ; i++) {
	ret = fgets (buf, (path_max + 1) * 2, fpin);
	if (ret == NULL)
	    break;
	ret2 = sscanf (buf, "%[^,],%[^\n]\n", path_buf, file_buf);
	if (ret2 != 2)
	    continue;
	fprintf (fpout, "<filename id=\"F%d\" index=\"%d\" " 
		 "file=\"%s\" path=\"%s\"/>\n", i, i, file_buf, path_buf);
    }

    fclose (fpin);
    fclose (fpout);
    return 0;
}
/* ==================================================================== */

